#include <iostream>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    int p[n];
    long long int d[n],k[q];

    for(int i=0;i<n;i++){
        cin>>d[i]>>p[i];
    }


       for(int i=0;i<q;i++){
        cin>>k[i];
    }
    int i=1,j=0;
long long int stanje=p[0],br=0,pojedeno=0;
    while(d[0]>k[j]){
     cout<<"0"<<endl;
     j++;
    }

while(j<q&&i<n){
    if(k[j]<d[i]){
        if(k[j]-d[i-1]<stanje){
       br=pojedeno+(k[j]-d[i-1])+1;
        cout<<br<<endl;
        }
    else{
        cout<<stanje<<endl;
    }
    j++;

    }
    stanje+=p[i];
    if(d[i]-d[i-1]<stanje){
        pojedeno=d[i]-d[i-1];
    }
    else{
        pojedeno=stanje;
    }
    i++;

}

while(j<q){
            if(k[j]-d[n-1]<stanje){
       br=pojedeno+(k[j]-d[n-1])+1;
        cout<<br<<endl;
        }
    else{
        cout<<stanje<<endl;
    }
    j++;



    }

    return 0;
}